use warnings;
use strict;
use Test::More tests => 3;
use Test::Exception;

use Time::HiRes qw( sleep );

use POWER::Event::Timer qw( :ALL );
use POWER::Utils;


my @Flag = (0, 0, 0, 0);

my @Results = (
    [ 1, 1, 1, 0 ],
    [ 1, 1, 2, 1 ],
    [ 1, 1, 3, 1 ],
);

set_timer({ cb=>sub{$Flag[0]++}, for=>0.1   });
set_timer({ cb=>sub{$Flag[1]++}, for=>0.1   });
set_timer({ cb=>sub{$Flag[2]++}, every=>0.1 });
set_timer({ cb=>sub{$Flag[3]++}, for=>0.2   });
for my $result (@Results) {
    sleep 0.1;
    run_callback(@$_) for get_expired_timers();
    is_deeply(\@Flag, $result);
}

