use warnings;
use strict;
use Test::More tests => 7;
use Test::Exception;

use Time::HiRes qw( sleep );

use POWER::Event::Timer qw( :ALL );
use POWER::Utils;


my $Flag = 0;
sub flag { $Flag++ }


my ($timer, $idle);

# can we set up repeated timer?
$timer = set_timer({ cb => \&flag, every => 0.1 });
ok(defined $timer, 'set_timer returned TIMER');

# is this timer will expire timely?
$Flag = 0;
for my $i (1 .. 3) {
    sleep 0.1;
    run_callback(@$_) for get_expired_timers();
    is($Flag, $i, 'flag() was executed timely');
}

# is timer still active?
$idle = get_timers_idle_time();
ok(0 < $idle && $idle < 0.1, 'timer still active');

# can we stop it?
lives_ok { stop_timer($timer) } 'timer stopped';
is(get_timers_idle_time(), undef, 'no more timers');

